unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, ShellApi,
  StdCtrls, ShlObj, ComObj, ExtCtrls, Grids, BrowseFolder, ComCtrls, DateUtils,
  TntStdCtrls, TntComCtrls, TntClasses;

type
  TForm1 = class(TForm)
    rgDir: TRadioGroup;
    rgpFolder: TRadioGroup;
    edtHD: TEdit;
    edtPath: TTntEdit;
    btnBrowser: TButton;
    btnStart: TButton;
    lvLog: TTntListView;
    btnStop: TButton;
    lblNow: TTntLabel;
    procedure FormCreate(Sender: TObject);
    procedure btnBrowserClick(Sender: TObject);
    procedure edtPathEnter(Sender: TObject);
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure edtHDEnter(Sender: TObject);
  private
    { Private declarations }
    procedure EnumHD;
    procedure RecurDir(Dir: widestring);
    function DoReName(Dir, oldfn: widestring): widestring;
  public
    { Public declarations }
  end;

function DragQueryFileW(Drop: HDROP; FileIndex: UINT; FileName: PWideChar; cb: UINT): UINT; stdcall;
function MoveFileW(lpExistingFileName, lpNewFileName: PWideChar): BOOL; stdcall;

var
  Form1: TForm1;

    cjk:    array[0..6180] of integer;
    udc:    array[0..$FFFE] of word;
    LogPath:string;
    Log:    Ttntstringlist;
implementation

{$R *.DFM}

function DragQueryFileW; external 'unicows.dll' name 'DragQueryFileW';
function MoveFileW; external 'unicows.dll' name 'MoveFileW';

procedure TForm1.EnumHD;
var
    DriveBits: set of 0..25;
    DriveNum, DriveType: Integer;
    DriveChar: Char;
    DrvType: UINT;
begin

    Integer(DriveBits) := GetLogicalDrives;
    for DriveNum := 0 to 25 do
        begin
        if not (DriveNum in DriveBits) then Continue;
        DriveChar := Char(DriveNum + Ord('A'));
        if (DriveNum = 0) or (DriveNum = 1) then
            begin  // Drive = A or B
            {floppy drive stuff}
            end
        else
            begin
            DrvType := GetDriveType(PChar(DriveChar + ':\'));
            if (DrvType = DRIVE_FIXED)  then edtHD.Text := edtHD.Text + DriveChar + ':\,';
            //if (DrvType = DRIVE_CDROM) then CDROM;
            end;
        end;
end;


procedure TForm1.FormCreate(Sender: TObject);
var
  F:    TextFile;
  S:    string;
  x,y:  integer;
  Map2: boolean;
  EnviormentStr: PChar;

begin
    ZeroMemory(@cjk, sizeof(cjk));
    ZeroMemory(@udc, sizeof(udc));
    Map2 := false;
    AssignFile(F, ExtractFilePath(paramstr(0)) + 'uc-o2n.tbl');
    Reset(F);
    while not Eof(F) do
        begin
        Readln(F, S);
        if S[1] = '=' then
            begin
            Map2 := true;
            Continue;
            end;
        x := StrToInt('$' + Copy(S, 1, 4));
        y := StrToInt('$' + Copy(S, 6, 4));
        cjk[x - $E024] := y;
        if Map2 then udc[y] := x;
        end;
    CloseFile(F);
    EnumHD;

    EnviormentStr:= AllocMem(MAX_PATH + 1);
    ExpandEnvironmentStrings('%USERPROFILE%', EnviormentStr, MAX_PATH);
    LogPath:= EnviormentStr + '\RenameLogs';
    FreeMem(EnviormentStr);
end;

procedure TForm1.btnBrowserClick(Sender: TObject);
var
   dlg: TBrowseForFolderDialog;
begin
   dlg := TBrowseForFolderDialog.Create;
   dlg.Title := 'пܸƧG';
   if dlg.Execute then
      edtPath.text := dlg.Path;
   dlg.Free;
   edtPath.SetFocus;
   rgpFolder.ItemIndex := 1;
end;

procedure TForm1.edtPathEnter(Sender: TObject);
begin
   rgpFolder.ItemIndex := 1;
    
end;

procedure TForm1.btnStartClick(Sender: TObject);
var
    x:      integer;
    dir:    string;
    aTime:  Tdatetime;
begin
    screen.cursor := crAppStart;
    lvLog.Items.Clear;
    Log := Ttntstringlist.Create;

    btnStart.Enabled := false;
    btnStop.Enabled := true;

    if rgpFolder.ItemIndex = 0 then
        for x := 67 to 90 do
            begin
            dir := chr(x);
            if pos(dir, edtHD.Text) <> 0 then
                RecurDir(dir + ':');
            end
    else
        RecurDir(edtPath.text);

    aTime := Now;
    Log.SaveToFile(LogPath + '\' + IntTostr(YearOf(aTime))+ Format('%.2d',[MonthOf(aTime)]) + Format('%.2d',[DayOf(aTime)]) + '-' + Format('%.2d',[HourOf(aTime)]) + Format('%.2d',[MinuteOf(aTime)]) + Format('%.2d',[SecondOf(aTime)]) + '.log' );
    Log.Free;
    btnStart.Enabled := true;
    btnStop.Enabled := false;
    screen.cursor := crDefault;


end;

procedure TForm1.RecurDir(Dir: widestring);
var
    LongPath: WideString;
    Data: TWin32FindDataW;
    Handle: THandle;
    ListItem: TtntListItem;
    ofn:    Widestring;
    rfn, rs:    Widestring;
begin
  lblNow.Caption := Dir;
  //if (Win32Platform = VER_PLATFORM_WIN32_NT) then
    begin
    if not DirectoryExists(LogPath) then CreateDir(LogPath);
    LongPath := dir + '\*.*';
    Handle := Windows.FindFirstFileW(PWideChar(LongPath), Data);
    if Handle <> INVALID_HANDLE_VALUE then
        begin
        repeat
        ofn := Data.cFileName;
        if copy(ofn,1,1) <> '.' then
            begin

            if Data.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY <> 0 then
                begin
                RecurDir(Dir +'\'+ ofn);
                rfn := '<'+ ofn + '>';     //is folder
                end
            else
                rfn := ofn;
            rs := DoReName(Dir, ofn);
            if rs <> '' then
                begin
                ListItem := lvLog.Items.Add;
                Listitem.Caption := rfn;
                Listitem.SubItems.Add(rs);
                Listitem.SubItems.Add(Dir);
                Log.Add('ӷG'+ Dir + '\' + rfn);
                Log.Add('令G'+ Dir + '\' + rs);
                Log.Add('');
                end;
            end;
        application.ProcessMessages;
        if btnStart.Enabled then exit;

        until not Windows.FindNextFileW(Handle, Data);
        Windows.FindClose(Handle)
        end;
    end;
end;

function TForm1.DoReName(Dir, oldfn: widestring): widestring;
var
    NumFiles: integer;
    newfn:  array[0..1023] of WideChar;
    fnLen:  integer;
    wrd:    word;
    x:   integer;
begin
    fnLen := Length(oldfn);
    for x := 0 to fnLen-1 do
        begin
        wrd := word(oldfn[x+1]);
        if rgDir.ItemIndex = 0 then
            begin
            if (wrd > $DFFF)and(wrd < $F900) then wrd := cjk[wrd - $E024];
            end
        else
            begin
            if udc[wrd] <> 0 then wrd := udc[wrd];
            end;
        newfn[x] := WideChar(wrd);
        end;
    newfn[fnLen] := #0;
    if oldfn = newfn then
        result := ''
    else
        if MoveFileW(PWideChar(Dir + '\' + oldfn), PWideChar(Dir + '\' + newfn)) then
            result := newfn
        else
            result := '*LkW*';

end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
    btnStart.Enabled := true;
    btnStop.Enabled := false;
end;

procedure TForm1.edtHDEnter(Sender: TObject);
begin
   rgpFolder.ItemIndex := 0;

end;

end.
